/*
 *   ****************** 8 bit lik Hamming Kodlamasi Simulasyonu *****************
 *
 *   Hazirlayan : Ahmet Bingul <bingul@gantep.edu.tr>
 *
 */

#include <stdio.h>
/*
 *     Global degiskenler tanimlaniyor...
 *   
 *   I[8] : gonderilen katar, 8 bit
 *   J[8] : alicida algilanan katar, 8 bit
 *   CI[4]: vericide hesaplanip gonderilen kontrol bitleri, 4 bit
 *   CJ[4]: alicida hesaplanan kontrol bitleri, 4 bit
 *   F[4] : XNOR mantigi ile, verici ve alicida hesaplanan kontrol bitlerini mukayese 
 *          eden yeni kontrol bitleri, 4 bit
 *   K[8] : duzeltilmis katar, 8 bit
 *  
 */

 int x,y;
 int I[8]={1,0,1,0,1,0,1,1};  /* Gonderilen bitler        */
 int J[8]={1,0,1,0,1,1,1,1};  /* Alicida algilanan bitler */

/* 
 * Mantik kapilari 
 *
 */

int NOT(x){
 if (x == 1) return 0;
 else        return 1;
}

int OR(x,y){
 if (x==0 && y==0) return 0;
 else              return 1;
}

int AND(x,y){
  if (x==1 && y==1) return 1;
  else              return 0;
}

int XOR(x,y){
 if (x != y) return 1;
 else        return 0;
}

int XNOR(x,y){
 return NOT( XOR(x,y) );
}

void kontrol(B,A)
int A[8],B[4];
{
 B[0] = XOR( XOR(A[0],A[1]),XOR(A[2],XOR(A[6],A[7])) );
 B[1] = XOR( XOR(A[0],A[3]),XOR(A[4],A[6]) );
 B[2] = XOR( XOR(A[1],A[3]),XOR(A[5],XOR(A[6],A[7])) );
 B[3] = XOR( XOR(A[2],A[5]),XOR(A[4],A[7]) );
}

void karsilastir(A,B,C)
int A[4],B[4],C[4];
{
 int i;
 for(i=0;i<4;i++){
      A[i]=XNOR( B[i],C[i] );
 }
}

void duzelt(K,F,J)
int K[8],F[4],J[8];
{
int i=0,j,k;

   do{
       for(j=0;j<4;j++){
        for(k=j+1;k<4;k++){
         if(i<=5)         {K[i] = XNOR( OR(F[j],F[k]),J[i] );}
         if(i>5 && i<=7 ) {K[i] = XNOR( OR(OR(F[j],F[k]),F[k+1]),J[i] );}
         i++;
        }
       }
   }while(i<8);
}

void yaz(I,J,K)
int I[8],J[8],K[8];
{
   int i;
   printf("\nGonderilen bitler        : ");for(i=0;i<8;i++){ printf("%d",I[i]); }   
   printf("\nAlicida algilanan bitler : ");for(i=0;i<8;i++){ printf("%d",J[i]); }
   printf("\nDuzeltilmis hali         : ");for(i=0;i<8;i++){ printf("%d",K[i]); }
   printf("\n\n");
}

/* 
 *  Ana program 
 *
 */

main(){
  int CI[4],CJ[4],F[4],K[8];
       kontrol(CI,I);
       kontrol(CJ,J);
       karsilastir(F,CI,CJ);
       duzelt(K,F,J);
       yaz(I,J,K);

return 0;
}
/* EOF */
